/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

import { ensureIsArray, QueryMode, t } from '@superset-ui/core';
export function getQueryMode(controls) {
  var _controls$query_mode, _controls$all_columns;
  var mode = controls == null || (_controls$query_mode = controls.query_mode) == null ? void 0 : _controls$query_mode.value;
  if (mode === QueryMode.aggregate || mode === QueryMode.raw) {
    return mode;
  }
  var rawColumns = controls == null || (_controls$all_columns = controls.all_columns) == null ? void 0 : _controls$all_columns.value;
  var hasRawColumns = rawColumns && rawColumns.length > 0;
  return hasRawColumns ? QueryMode.raw : QueryMode.aggregate;
}

/**
 * Visibility check
 */
export function isQueryMode(mode) {
  return _ref => {
    var {
      controls
    } = _ref;
    return getQueryMode(controls) === mode;
  };
}
export var isAggMode = isQueryMode(QueryMode.aggregate);
export var isRawMode = isQueryMode(QueryMode.raw);
export var validateAggControlValues = (controls, values) => {
  var areControlsEmpty = values.every(val => ensureIsArray(val).length === 0);
  return areControlsEmpty && isAggMode({
    controls
  }) ? [t('Group By, Metrics or Percentage Metrics must have a value')] : [];
};